Package: Select
Title: Determines Species Probabilities Based on Functional Traits
Version: 1.6
Authors@R: c(
    person("Daniel", "Laughlin", email = "danielclaughlin@gmail.com", role = c("cre","aut")),
    person("Loic", "Chalmandrier", email = "lchalman@uwyo.edu", role = "aut"))
Description: The objective of these functions is to derive a species assemblage
    that satisfies a functional trait profile. Restoring resilient ecosystems
    requires a flexible framework for selecting assemblages that are based on the
    functional traits of species. However, current trait-based models have been
    limited to algorithms that can only select species by optimising specific trait
    values, and could not elegantly accommodate the common desire among restoration
    ecologists to produce functionally diverse assemblages. We have solved this
    problem by applying a non-linear optimisation algorithm that optimises Rao Q,
    a closed-form functional trait diversity index that incorporates species
    abundances, subject to other linear constraints. This framework generalises
    previous models that only optimised the entropy of the community, and can
    optimise both functional diversity and entropy simultaneously. This package
    can also be used to generate experimental assemblages to test the effects
    of community-level traits on community dynamics and ecosystem function. The
    method is based on theory discussed in Laughlin (2014, Ecology Letters)
    and Laughlin et al. (2018, Methods in Ecology and Evolution).
Depends: R (>= 3.3.0)
Imports: Rsolnp, latticeExtra, grDevices, stats, lattice, graphics,
        ade4
License: GPL (>= 2)
Encoding: UTF-8
LazyData: true
RoxygenNote: 7.3.3
Suggests: knitr, rmarkdown, testthat, FD
VignetteBuilder: knitr
NeedsCompilation: no
Packaged: 2026-04-23 19:45:38 UTC; danielclaughlin
Author: Daniel Laughlin [cre, aut],
  Loic Chalmandrier [aut]
Maintainer: Daniel Laughlin <danielclaughlin@gmail.com>
Repository: CRAN
Date/Publication: 2026-04-24 06:50:02 UTC
Built: R 4.6.0; ; 2026-04-26 10:16:05 UTC; unix

        select - extract fields from simple text databases

This is similar in concept to a SQL SELECT statement.  It operates
on simple text database files - each record is one line in the
file, and data items are separated by the designated field separator
character, generally tab.

See the manual entry for more details.

Files in this distribution:

    README		this
    Makefile		guess
    select.c		source file
    select.1		manual entry
    strlist.h		header file for string list package
    strlist.c		source file for string list package
    strtab.h		header file for string table package
    strtab.c		source file for string table package

Feedback is welcome - send bug reports, enhancements, checks, money
orders, etc. to the addresses below.

    Jef Poskanzer  jef@mail.acme.com  http://www.acme.com/jef/

## ----setup, include = FALSE---------------------------------------------------
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>"
)
library(Select)
library(lattice)
library(FD)

## -----------------------------------------------------------------------------
### Set size of species pool
Spp <- 5

### Set trait values for each species as integers from 1 to 5 (Spp)
### Note that we make this a matrix to pass it into the function
trait <- as.matrix(data.frame(trait = c(1:Spp)))

### Most datasets have species names as row names, so let's add arbitrary row names using letters
rownames(trait) <- c(letters[1:nrow(trait)])

## -----------------------------------------------------------------------------
### Store results from selectSpecies() into 'result1'
result1 <- selectSpecies(t2c = trait, constraints = c(trait=3.5), t2d = trait, obj = "H")

# Use the plotProbs() function to plot the abundance distribution
plotProbs(result1, trait, xlab = "Species")

## -----------------------------------------------------------------------------
### compare result1 with identical maxent output from FD package. Be sure to have the FD package installed.
round(FD::maxent(constr = c(3.5), states = trait)$prob, 5)
round(t(result1$prob), 5)

## -----------------------------------------------------------------------------
### Store results from selectSpecies() into 'result2'. Note the only difference with result1 is a different objective function (Q).
result2 <- selectSpecies(t2c = trait, constraints = c(trait=3.5), t2d = trait, obj = "Q")

# plot result2
plotProbs(result2, trait, xlab = "Species")

## -----------------------------------------------------------------------------
### Store results from selectSpecies() into 'result3'. Note the only difference with result2 is a different objective function (QH)
result3 <- selectSpecies(t2c = trait, constraints = c(trait=3.5), t2d = trait, obj="QH")

# plot result3
plotProbs(result3, trait, xlab = "Species")

## -----------------------------------------------------------------------------
### Store results from selectSpecies() into 'result4'
result4 <- selectSpecies(t2d = trait, obj = "QH")

# plot result4
plotProbs(result4, trait, xlab = "Species")


## -----------------------------------------------------------------------------
### 2-dimensional trait matrix of 16 species, evenly spaced between trait values 1 through 4
trait.matrix <- as.matrix(cbind(traitX = c(rep(1,4), rep(2,4), rep(3,4), rep(4,4)), traitY = c(rep(c(1,2,3,4),4))))

### specify species names
rownames(trait.matrix) <- c(letters[1:16])

## -----------------------------------------------------------------------------
### Create two evenly-spaced orthogonal traits
traitX <- matrix(c(rep(1,4), rep(2,4), rep(3,4), rep(4,4)))
traitY <- matrix(c(rep(c(1,2,3,4),4)))
rownames(traitX) <- c(letters[1:16]); colnames(traitX) <- c("traitX")
rownames(traitY) <- c(letters[1:16]); colnames(traitY) <- c("traitY")

### Store results from selectSpecies() into 'result5'
result5 <- selectSpecies(t2c = traitX, constraints = c(traitX=3.5), t2d = traitY, obj = "Q", capd = FALSE)

### plot result5
trait.matrix <- cbind(traitX, traitY)
plotProbs(result5, trait.matrix, cex.lab = 0.7)

## -----------------------------------------------------------------------------
### Store results from selectSpecies() into 'result6'
# obj: select the QH objective function to maximize both Rao's Q and H, and cap the distance matrix by setting capd = TRUE
result6 <- selectSpecies(t2c = traitX, constraints = c(traitX=3.5), t2d = traitY, obj = "QH", capd = TRUE)

### plot result6
plotProbs(result6, trait.matrix, cex.lab = 0.7)

## -----------------------------------------------------------------------------
### load serpentine data (available in the R package) 
data(serpentine)

### take logs and rescale to unit variance
wue <- data.frame(wue = scale(log(serpentine$wue)))
rootdepth <- data.frame(rootdepth = scale(log(serpentine$rootdepth)))

### transfer species row names
rownames(wue) <- rownames(serpentine)
rownames(rootdepth) <- rownames(serpentine)

# set constraint on wue as the 67% quantile of wue distribution
wue.constraint <- c(quantile(wue$wue, 0.67))
names(wue.constraint) <- c("wue")

## -----------------------------------------------------------------------------
### Store results from selectSpecies() into 'result7'
result7 <- selectSpecies(t2c = as.matrix(wue), constraints = c(wue.constraint), t2d = as.matrix(rootdepth), capd = TRUE, obj = "QH")

### plot result7
plotProbs(result7, traits = cbind(wue,rootdepth), xlab = "Water use efficiency", ylab = "Rooting depth", colors = c("darkolivegreen4", "gold2"), cex.lab = 0.7)

#' Select species based on traits
#'
#' This function returns a probability distribution for a species pool based on their traits and a desired trait profile (Laughlin 2014). It can simultaneously constrain specific trait value(s) and optimise functional diversity.
#'
#' @param t2c "Traits to constrain": A matrix of species trait values, where species are organized as rows and traits as columns. These should be numeric arrays, and no missing values are tolerated. Ordinal data will yield meaningful results, but nominal data entered as numeric vectors are invalid. Row and column names are optional. This matrix can be any dimension, but the number of traits should be less than the number of species.
#' @param constraints Trait constraints: A vector of trait values that serve as constants in the constraint equations. If not specified, the function will not constrain solutions to trait means. These trait contraints must be listed in the same order as columns in t2c. These constraints are community-weighted mean trait values, i.e., average traits weighted by the relative abundance of each species.
#' @param t2d "Traits to diversify": Can be 1) a matrix of species trait values to diversify where species are organized as rows and traits as columns. NAs are tolerated as long as each pair of species can be compared by at least one trait. In this case, dissimilarities among species are computed using Euclidean distance. The number of species in t2d must match those in t2c. Or 2) a distance matrix of class 'dist' that contains dissimilarities among species, no NAs are tolerated in the distance matrix.
#' @param obj Objective function: The objective function to optimise, one of three possibilities = c("QH", "Q", "H"). QH = Quadratic entropy (Q) plus entropy (H'); Q = Quadratic entropy; H = entropy.
#' @param phi A parameter bounded between 0 and 1 that weights the importance of either quadratic entropy or entropy (default = 0.5). Phi of 1 corresponds to 100 percent Q, phi of 0.5 corresponds to 50 percent Q and 50 perfect H', phi of 0 corresponds to 100 percent H'.
#' @param capd A logical stating whether the distance matrix should be capped at the mean distance among species (default = FALSE). Mean distance is calculated as the average of all upper triangular entries in the distance matrix calculated from t2d.
#' @param euclid A logical stating whether the distance matrix should be transformed to an Euclidean matrix if necessary (default = TRUE).
#' @return A list with the elements: \item{prob}{Probabilities, i.e. optimal solutions of species relative abundance} \item{cwm_t2d}{Community-weighted mean trait values of resulting community for traits that were diversified, computed as probabilities x t2d using matrix multiplication} \item{cwm_t2c}{Community-weighted mean trait values of resulting community for traits that were constrained, computed as probabilities x t2d using matrix multiplication} \item{H}{Final entropy of community} \item{Q}{Final Rao Q of community} \item{objval}{Values of the objective function being maximized. The last value is the maximum.} \item{lagrange}{Lagrange multipliers.} \item{hessian}{The Hessian at the optimal solution.}
#' @examples
#' ### 1 trait constraint with maximum entropy
#' Spp <- 5 #S = number of species
#' trait <- as.matrix(data.frame(trait=c(1:Spp)))
#' rownames(trait) <- c(letters[1:nrow(trait)])
#' result1 <- selectSpecies(t2c=trait, constraints=c(trait=3.5), t2d=trait, obj="H", capd=FALSE)

#' ### compare result1 with virtually identical maxent output from FD package
#' #FD::maxent(constr=c(3.5),states=trait)$prob

#' ### 1 trait constraint with maximum functional diversity
#' result2 <- selectSpecies(t2c=trait, constraints=c(trait=3.5), t2d=trait, obj="Q", capd=FALSE)

#' ### 1 trait constraint with maximum functional diversity and entropy
#' result3 <- selectSpecies(t2c=trait, constraints=c(trait=3.5), t2d=trait, obj="QH", capd=FALSE)
#'
#' ### Plot results
#' plotProbs(result1,trait, xlab="Trait")
#' plotProbs(result2,trait, xlab="Trait")
#' plotProbs(result3,trait, xlab="Trait")
#'
#' ### 1 trait and no trait constraint
#' result4 <- selectSpecies(t2d=trait, obj="QH", capd=FALSE)
#' plotProbs(result4,trait, xlab="Trait")
#'
#' ##### 2 traits: Constrain trait X at X=3, diversify trait Y
#' traitX <- matrix(c(rep(1,4),rep(2,4),rep(3,4),rep(4,4)))
#' traitY <- matrix(c(rep(c(1,2,3,4),4)))
#' rownames(traitX) <- c(letters[1:16]); colnames(traitX) <- c("traitX")
#' rownames(traitY) <- c(letters[1:16]); colnames(traitY) <- c("traitY")
#'
#' result5 <- selectSpecies(t2c=traitX,constraints=c(traitX=3),t2d=traitY,obj="Q",capd=FALSE)
#' result6 <- selectSpecies(t2c=traitX,constraints=c(traitX=3),t2d=traitY,obj="QH",capd=TRUE)
#'
#' trait.matrix <- cbind(traitX, traitY)
#' plotProbs(result5,trait.matrix)
#' plotProbs(result6,trait.matrix)
#'
#' ##### 3 traits: Constrain trait Z to value 2.5, diversify trait X and Y
#' traitZ <- as.matrix(data.frame(c(1,3,2,2,3,1,2,3,1,2,1,3,2,3,2,2)))
#' rownames(traitZ) <- c(letters[1:16]); colnames(traitZ) <- c("traitZ")
#' result7 <- selectSpecies(t2c=traitZ,constraints=c(traitZ=2.5),t2d=trait.matrix, capd=TRUE, obj="QH")
#' plotProbs(result7,trait.matrix)
#'
#' @references Laughlin, D.C. 2014. Applying trait-based models to achieve functional targets for theory-driven ecological restoration. Ecology Letters, 17, 771-784.
#' @export

selectSpecies <- function (t2c = NULL, constraints = NULL, t2d, obj = c("QH","Q", "H"),
                           phi = 0.5, capd = FALSE, euclid = TRUE) 
{
  if (!is.null(t2c)) {
    if (!inherits(t2c, "matrix") | !is.numeric(t2c)) {
      stop("object \"t2c\" is not a numerical matrix")
    }
    obj <- match.arg(obj)
    if (ncol(t2c) >= nrow(t2c) - 1) {
      stop("There are more traits than species. Use fewer traits or more species.")
    }
    if (any(is.na(t2c))) {
      stop("Traits to constrain \"t2c\" contains NA")
    }
    if (is.null(colnames(t2c))) 
      warning("\"t2c\" colname vector (traits) is empty")
    if (is.null(rownames(t2c))) 
      warning("\"t2c\" rowname vector (species) is empty")
  }
  if (phi < 0 | phi > 1 | !is.numeric(phi)) {
    stop("phi must be between 0 and 1")
  }
  if (inherits(t2d, "matrix") & is.numeric(t2d)) {
    if (is.null(colnames(t2d))) 
      warning("\"t2d\" colname vector (traits) is empty")
    if (is.null(rownames(t2d))) 
      warning("\"t2d\" rowname vector (species) is empty")
    d <- stats::dist(t2d, upper = TRUE, diag = TRUE)
  }
  else if (inherits(t2d, "dist")) {
    d <- t2d
    if(inherits(names(t2d), "list")){
    	if (is.null(rownames(t2d))) 
    		warning("\"t2d\" rowname vector (species) is empty")
    } else{
    	if (is.null(names(t2d))) 
    		warning("\"t2d\" name vector (species) is empty")	
    }
  }
  else {
    stop("object \"t2d\" must be a numerical trait matrix or a \"dist\" matrix")
  }
  if (any(is.na(d))) 
    stop("Distance matrix \"t2d\" contains NA")
  oldw <- getOption("warn")
  options(warn = -1)
  test <- !ade4::is.euclid(d)
  options(warn = oldw)
  if (euclid & test) 
    d <- as.matrix(ade4::quasieuclid(stats::as.dist(d)))
  d <- as.matrix(d)
  if (!is.null(t2c)) {
    if (nrow(d) != nrow(t2c)) {
      stop("objects \"t2d\" and \"t2c\" do not describe the same number of species")
    }
    if (!is.null(row.names(d)) & !is.null(row.names(t2c)) & 
        !identical(row.names(d), row.names(t2c))) {
      stop("\"t2d\" and \"t2c\" species names do not match")
    }
  }
  if (!is.null(constraints)) {
    if (is.null(t2c)) {
      stop("If \"constraints\" is specified, \"t2c\" must be specified")
    }
    if (length(constraints) != ncol(t2c)) {
      stop("Number of trait constraints number must be equal to the number of traits to constrain.")
    }
    if (!is.numeric(constraints) | any(is.na(constraints))) {
      stop("Trait constraint must all be numerical non-missing values.")
    }
    range_t2c <- apply(t2c, 2, range)
    if (any(range_t2c[1, ] > constraints | range_t2c[2, ] < 
            constraints)) {
      stop("Trait constraint must be within the range of available trait values in the species pool.")
    }
    if (!is.null(names(constraints)) & !is.null(colnames(t2c)) & 
        !identical(names(constraints), colnames(t2c))) {
      stop("\"constraints\" and \"t2c\" trait names don't match")
    }
    if (is.null(names(constraints))) 
      warning("\"constraints\" name vector is empty")
  }
  N <- nrow(d)
  mean.dist <- mean(d[upper.tri(d, diag = FALSE)])
  dcap.fun <- function(d) {
    d[d > mean.dist] <- mean.dist
    return(d)
  }
  if (capd) {
    d <- dcap.fun(d)
  }
  mean.t2d <- mean(t2d)
  tdist <- abs(t2d - mean.t2d)
  tdist[tdist == 0] <- 0.001
  qh <- function(p) {
    -(t(p) %*% (d/2) %*% p * phi + -(t(p) %*% log(p)) * (1 - 
                                                           phi))
  }
  q <- function(p) {
    -(t(p) %*% (d/2) %*% p)
  }
  h <- function(p) {
    -(-(t(p) %*% log(p)))
  }
  if (!is.null(constraints)) {
    eqfun <- function(p) {
      z1 <- sum(p)
      cwms <- t(as.matrix(p)) %*% t2c
      return(c(z1, cwms))
    }
    all.constraints <- c(1, constraints)
  }
  else {
    eqfun <- function(p) {
      z1 <- sum(p)
      return(z1)
    }
    all.constraints <- 1
  }
  oldw <- getOption("warn")
  options(warn = -1)
  if (obj == "QH") {
    res <- Rsolnp::solnp(pars = c(rep(1/N, N)), fun = qh, 
                         eqfun, eqB = all.constraints, LB = c(rep(0, N)), 
                         UB = c(rep(1, N)))
  }
  else if (obj == "Q") {
    res <- Rsolnp::solnp(pars = c(rep(1/N, N)), fun = q, 
                         eqfun, eqB = all.constraints, LB = c(rep(0, N)), 
                         UB = c(rep(1, N)))
  }
  else if (obj == "H") {
    res <- Rsolnp::solnp(pars = c(rep(1/N, N)), fun = h, 
                         eqfun, eqB = all.constraints, LB = c(rep(0, N)), 
                         UB = c(rep(1, N)))
  }
  result = list()
  result$prob <- as.matrix(res$pars)
  if (inherits(t2d, "matrix")) {
    rownames(result$prob) <- row.names(t2d)
    result$cwm_t2d <- as.matrix(res$pars %*% t2d)
  }
  else {
  	if(inherits(names(t2d), "list")){
  		rownames(result$prob) <- rownames(t2d)
  	} else{
  		rownames(result$prob) <- names(t2d)	
  	}
  }
  if (!is.null(t2c)) {
    result$cwm_t2c <- as.matrix(res$pars %*% t2c)
  }
  result$H <- h(res$pars) * -1
  result$Q <- q(res$pars) * -1
  result$objval <- as.matrix(res$values)
  result$lagrange <- as.matrix(res$lagrange)
  result$hessian <- as.matrix(res$hessian)
  result$convergence <- res$convergence
  options(warn = oldw)
  return(result)
}

library(Select)
context("Input checks")

test_that("t2c format",{
  t2c <- cbind(t1 = runif(15), t2 = runif(15))
  constraints = c(0.2,0.6)
  t2d <- cbind(t1 = runif(15), t2 = runif(15))
  row.names(t2d) <- row.names(t2c) <- letters[1:15]

  # t2c is not numeric
  t2c_err <- t2c
  t2c_err[1,1] <- "A"
  expect_error(selectSpecies(t2c_err, constraints, t2d, obj = "Q", phi = 0.3, euclid = F, capd = F), "object \"t2c\" is not a numerical matrix")

  # t2c is not a matrix
  t2c_err <- runif(15)
  expect_error(selectSpecies(t2c_err, constraints, t2d, obj = "Q", phi = 0.3, euclid = F, capd = F), "object \"t2c\" is not a numerical matrix")
})

test_that("t2d format",{
  t2c <- cbind(t1 = runif(15), t2 = runif(15))
  constraints = c(0.2,0.6)
  t2d <- cbind(t1 = runif(15), t2 = runif(15))
  row.names(t2d) <- row.names(t2c) <- letters[1:15]

  # t2d is not numeric
  t2d_err <- t2d
  t2d_err[1,1] <- "A"
  expect_error(selectSpecies(t2c, constraints, t2d_err, obj = "Q", phi = 0.3, euclid = F, capd = F), "object \"t2d\" must be a numerical trait matrix or a \"dist\" matrix")

  # t2d is not a matrix
  t2d_err <- runif(15)
  expect_error(selectSpecies(t2c, constraints, t2d_err, obj = "Q", phi = 0.3, euclid = F, capd = F), "object \"t2d\" must be a numerical trait matrix or a \"dist\" matrix")

    # t2d contains NA
  t2d_err <- dist(t2d)
  t2d_err[1]<-NA
  expect_error(selectSpecies(t2c, constraints, t2d_err, obj = "Q", phi = 0.3, euclid = F, capd = F), "Distance matrix \"t2d\" contains NA")

  })

test_that("constrain format",{
  t2c <- cbind(t1 = runif(15), t2 = runif(15))
  constraints = c(0.2,0.6)
  t2d <- cbind(t1 = runif(15), t2 = runif(15))
  row.names(t2d) <- row.names(t2c) <- letters[1:15]

  # t2d is not numeric
  constraints_err <- c("E", 0.1)
  expect_error(selectSpecies(t2c, constraints_err, t2d, obj = "Q", phi = 0.3, euclid = F, capd = F), "Trait constraint must all be numerical non-missing values.")
  constraints_err <- c(NA, 0.1)
  expect_error(selectSpecies(t2c, constraints_err, t2d, obj = "Q", phi = 0.3, euclid = F, capd = F), "Trait constraint must all be numerical non-missing values.")

})

test_that("phi format",{
  t2c <- cbind(t1 = runif(15), t2 = runif(15))
  constraints = c(0.2,0.6)
  t2d <- cbind(t1 = runif(15), t2 = runif(15))
  row.names(t2d) <- row.names(t2c) <- letters[1:15]

  # t2d is not numeric
  phi_err <-2
  expect_error(selectSpecies(t2c, constraints_err, t2d, obj = "Q", phi = phi_err, euclid = F, capd = F), "phi must be between 0 and 1")
  phi_err <--1
  expect_error(selectSpecies(t2c, constraints_err, t2d, obj = "Q", phi = phi_err, euclid = F, capd = F), "phi must be between 0 and 1")
  phi_err <-NA
  expect_error(selectSpecies(t2c, constraints_err, t2d, obj = "Q", phi = phi_err, euclid = F, capd = F), "phi must be between 0 and 1")
  phi_err <- "A"
  expect_error(selectSpecies(t2c, constraints_err, t2d, obj = "Q", phi = phi_err, euclid = F, capd = F), "phi must be between 0 and 1")
})

test_that("t2c and constrain matching",{
  t2c <- cbind(t1 = runif(15), t2 = runif(15))
  constraints = c(0.2,0.6)
  t2d <- cbind(t1 = runif(15), t2 = runif(15))
  row.names(t2d) <- row.names(t2c) <- letters[1:15]

  # Dimensions don't match
  constraints_err <- constraints[-1]
  expect_error(selectSpecies(t2c, constraints_err, t2d, obj = "Q", phi = 0.3, euclid = F, capd = F))

  # Constraints are out of range
  constraints_err <- c(5,0.2)
  expect_error(selectSpecies(t2c, constraints_err, t2d, phi = 0.3, euclid = F, capd = F))

  # Constraints are out of range
  constraints_err <- c(0.6,-0.2)
  expect_error(selectSpecies(t2c, constraints_err,t2d, obj = "Q", t2d, phi = 0.3, euclid = F, capd = F))
})

test_that("t2d and t2c matching",{
  t2c <- cbind(t1 = runif(15), t2 = runif(15))
  constraints = c(0.2,0.6)
  t2d <- cbind(t1 = runif(15), t2 = runif(15))
  row.names(t2d) <- row.names(t2c) <- letters[1:15]

  # Dimensions don't match
  t2d_err <- t2d[-1,]
  expect_error(selectSpecies(t2c, constraints, t2d_err, obj = "Q", phi = 0.3, euclid = F, capd = F))

  # Species names don't match
  t2d_err <- t2d
  row.names(t2d_err) <- rev(row.names(t2d_err))
  expect_error(selectSpecies(t2c, constraints, t2d_err, obj = "Q", phi = 0.3, euclid = F, capd = F))

  # With a distance matrix
  t2c <- cbind(t1 = runif(15), t2 = runif(15))
  constraints = c(0.2,0.6)
  t2d <- cbind(t1 = runif(15), t2 = runif(15))
  row.names(t2d) <- row.names(t2c) <- letters[1:15]

  # Dimensions don't match
  t2d_err <- t2d[-1,]
  expect_error(selectSpecies(t2c, constraints, dist(t2d_err), obj = "Q", phi = 0.3, euclid = F, capd = F))

  # Species names don't match
  t2d_err <- t2d
  row.names(t2d_err) <- rev(row.names(t2d_err))
  expect_error(selectSpecies(t2c, constraints, dist(t2d_err), obj = "Q", phi = 0.3, euclid = F, capd = F))
})

test_that("Test result",{
  t2c <- cbind(t1 = c(0,0.5,1))
  constraints = 0.5
  t2d <- t2c
  expect <- as.matrix(rep(1/3,3))
  row.names(t2d) <- row.names(t2c) <- row.names(expect) <- letters[1:3]

  # Test H function
  expect_equal(selectSpecies(t2c, constraints, t2d, obj = "H", phi = 0.5, euclid = F, capd = F)$prob, expect, tolerance = 0.001)
  expect_equal(as.numeric(selectSpecies(t2c, constraints, t2d, obj = "H", phi = 0.5, euclid = F, capd = F)$H), log(3), tolerance = 0.001)
  expect_equal(as.numeric(selectSpecies(t2c, constraints, t2d, obj = "H", phi = 0.5, euclid = F, capd = F)$Q), 1/4.5, tolerance = 0.001)
  expect_equal(as.numeric(selectSpecies(t2c, constraints, t2d, obj = "H", phi = 0.5, euclid = F, capd = F)$cwm_t2c), 0.5, tolerance = 0.001)

  # Test Q function
  expect <- as.matrix(c(0.5,0,0.5))
  row.names(expect) <- letters[1:3]
  expect_equal(selectSpecies(t2c, constraints, t2d, obj = "Q", phi = 0.5, euclid = F, capd = F)$prob, expect, tolerance = 0.001)
  expect_equal(as.numeric(selectSpecies(t2c, constraints, t2d, obj = "Q", phi = 0.5, euclid = F, capd = F)$H), log(2), tolerance = 0.001)
  expect_equal(as.numeric(selectSpecies(t2c, constraints, t2d, obj = "Q", phi = 0.5, euclid = F, capd = F)$Q), 0.25, tolerance = 0.001)
  expect_equal(as.numeric(selectSpecies(t2c, constraints, t2d, obj = "Q", phi = 0.5, euclid = F, capd = F)$cwm_t2c), 0.5, tolerance = 0.001)
})

#' Functional trait data for species in serpentine grassland
#'
#' A dataset containing two traits for species in a serpentine grassland.
#' The variables are as follows:
#'
#' \itemize{
#'   \item species. species name
#'   \item wue. average water use efficiency, rate of carbon assimilation per unit of water used
#'   \item rootdepth. average rooting depth in soil
#' }
#'
#' @docType data
#' @keywords datasets
#' @name serpentine
#' @format dataframe of 48 species and 2 traits
#' @usage data(serpentine)
#' @source Funk, J.L. & Wolf, A.A. 2016. Testing the trait based community framework: Do functional traits predict competitive outcomes? Ecology 97:2206-2211.
#'
"serpentine"

#' Plots results from the selectSpecies function
#'
#' This function plots results (species probabilities/optimum solutions) from the selectSpecies() function
#'
#' @param result A saved object from function selectSpecies()
#' @param traits A matrix of trait values where traits are columns and rows are species. If one trait is provided, then the function creates a 2D barplot of probabilities for each species. If two traits are provided, then the function creates a 3D barplot that illustrates probabilities of species located within a 2D trait space.
#' @param colors An optional vector of colors for plotting that must include at least two valid color names. The default color scheme is a ramp palette of lightblue to blue.
#' @param xlim Vector of two numbers denoting limits on x-axis.
#' @param ylim Vector of two numbers denoting limits on y-axis.
#' @param xlab Character string to describe x-axis.
#' @param ylab Character string to describe y-axis.
#' @param zlab Character string to describe z-axis. The default axis names is "Probabilities".
#' @param distance An optional number denoting distance between bars in 3d plot.
#' @param cex.lab An optional number denoting the size of the labels. The default is set to 1.5.
#' @param box.col An optional setting for the color of the box. The default setting is transparent.
#' @param xbase The length of the base of each 3d bar along the x-axis
#' @param ybase The length of the base of each 3d bar along the y-axis
#' @param ... Additional arguments to pass to barplot() or lattice::cloud()
#' @return 2D barplot of probabilities for each species or 3D barplot that illustrates probabilities of species located within a 2D trait space
#' @export
#' @examples
#' ### 1 trait constraint with maximum functional diversity and entropy
#' Spp <- 5 #S = number of species
#' trait <- as.matrix(data.frame(trait=c(1:Spp)))
#' rownames(trait) <- c(letters[1:nrow(trait)])
#' result1 <- selectSpecies(t2c=trait, constraints=c(3.5), t2d=trait, obj="QH", capd=FALSE)
#' plotProbs(result1,trait, xlab="Trait")
#'
#' ##### 2 traits: Constrain trait X to value 2.5, diversify trait Y
#' traitX <- matrix(c(rep(1,3),rep(2,3),rep(3,3)))
#' traitY <- matrix(c(rep(c(1,2,3),3)))
#' rownames(traitX) <- c(letters[1:9]); colnames(traitX) <- c("traitX")
#' rownames(traitY) <- c(letters[1:9]); colnames(traitY) <- c("traitY")
#' result2 <- selectSpecies(t2c=traitX,constraints=c(traitX=2.5),t2d=traitY,capd=TRUE,obj="QH")
#' plotProbs(result2,traits = cbind(traitX, traitY))

plotProbs <- function (result, traits, colors = c("lightblue", "blue"), xlim = NULL, ylim = NULL,
                       xlab = NULL, ylab = NULL, zlab = "Probability", distance = 0.3, cex.lab = 1.5, box.col = "transparent",
                       xbase = 0.5, ybase = 0.5,...)
{
  res <- result$prob
  cols <- function(n) {
    (grDevices::colorRampPalette(colors = colors))(20)
  }
  if (ncol(traits) == "1") {
    graphics::barplot(t(res), col = colors[2],
                      names = rownames(res), ylab = ifelse(is.null(ylab), "Probability", ylab),
                      xlab = ifelse(is.null(xlab), "Trait X", xlab),...)
  }
  if (ncol(traits) == "2") {
    if (is.null(xlim)) xlim <- c(min(traits[,1]) - 1, max(traits[, 1]) + 1)
    if (is.null(ylim)) ylim <- c(min(traits[,2]) - 1, max(traits[, 2]) + 1)

    lattice::cloud(res ~ as.vector(t(traits[, 1])) + as.vector(t(traits[,2])), panel.3d.cloud = latticeExtra::panel.3dbars,
                   xbase = xbase, ybase = ybase, scales = list(arrows = FALSE,col = 1), perspective = TRUE,
                   distance = distance, xlim = xlim, ylim = ylim,
                   par.settings = list(axis.line = list(col = box.col)),
                   xlab = list(ifelse(is.null(xlab), "Trait X", xlab), rot = 50),
                   ylab = list(ifelse(is.null(ylab), "Trait Y", ylab), rot = -30),
                   zlab = list(zlab,rot = 90), screen = list(z = 55, x = -55),
                   col.facet = lattice::level.colors(res, at = lattice::do.breaks(range(res), 20), col.regions = cols, colors = TRUE),...)
  }
}

#' Functional trait data for understory species in ponderosa pine forest
#'
#' A dataset containing two traits for species in a pine forest.
#' The variables are as follows:
#'
#' \itemize{
#'   \item species. species name
#'   \item flrdate. average flowering date in day of year
#'   \item leafcn. average leaf carbon-to-nitrogen ratio
#' }
#'
#' @docType data
#' @keywords datasets
#' @name pineforest
#' @format dataframe of 46 species and 2 traits
#' @usage data(pineforest)
#' @source Laughlin, D.C., J.J. Leppert, M.M. Moore, and C.H. Sieg. 2010. A multi-trait test of the leaf-height-seed plant strategy scheme with 133 species from a pine forest flora. Functional Ecology 24:493-501.
#'
"pineforest"

#' Functional trait data for tree species in tropical forest
#'
#' A dataset containing two traits for species in a tropical forest.
#' The variables are as follows:
#'
#' \itemize{
#'   \item species. species name
#'   \item sla. specific leaf area
#'   \item wd. wood density
#' }
#'
#' @docType data
#' @keywords datasets
#' @name tropicalforest
#' @format dataframe of 41 species and 2 traits
#' @usage data(tropicalforest)
#' @source McCarthy, James K. 2018. Predicting the diversity and functional composition of woody plant communities under climate change PhD Thesis, School of Biological Sciences, The University of Queensland. Advisor: Dr. John Dwyer. doi:10.14264/uql.2018.134
#'
"tropicalforest"

---
title: "Vignette for using the selectSpecies( ) function"
author: "Daniel C. Laughlin, Loic Chalmandrier, Chaitanya Joshi, Michael Renton, John M. Dwyer, and Jennifer L. Funk"
date: "23 April 2026"
output: rmarkdown::html_vignette
vignette: >
  %\VignetteIndexEntry{Vignette for using the selectSpecies( ) function}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

```{r setup, include = FALSE}
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>"
)
library(Select)
library(lattice)
library(FD)
```
# Introduction

This package determines species probabilities (i.e., relative abundances) that satisfy a given functional trait profile. Restoring resilient ecosystems requires a flexible framework for selecting assemblages that are based on the functional traits of species. However, current trait-based models have been limited to algorithms that can only select species by optimising specific trait values, and could not elegantly accommodate the common desire among restoration ecologists to produce functionally diverse assemblages. We have solved this problem by applying a non-linear optimisation algorithm that optimises Rao Q, a closed-form functional trait diversity index that incorporates species abundances, subject to other linear constraints. This framework generalises previous models that only optimised the entropy of the community, and can optimise both functional diversity and entropy simultaneously. This package can also be used to generate experimental assemblages to test the effects of community-level traits on community dynamics and ecosystem function.

There are two functions in this package:  
selectSpecies( ): This function generates the species assemblages according to the user-defined trait profile.  
plotProbs( ): This function plots the relative abundances of the species along the axes of either one or two traits.  

## The selectSpecies( ) function takes the following arguments:

t2c: Traits to constrain: A matrix of species trait values, where species are organized as rows and traits as columns. These should be numeric arrays, and no missing values are tolerated. Ordinal data will yield meaningful results, but nominal data entered as numeric vectors are invalid. Row and column names are optional. This matrix can be any dimension, but the number of traits should be less than the number of species.
  
constraints: Trait constraints: A vector of trait values that serve as constants in the constraint equations. If not specified, the function will not constrain solutions to trait means. These trait contraints must be listed in the same order as columns in t2c. These constraints are community-weighted mean trait values, i.e., average traits weighted by the relative abundance of each species.
  
t2d: Traits to diversify: Can be 1) a matrix of species trait values to diversify where species are organized as rows and traits as columns. NAs are tolerated as long as each pair of species can be compared by at least one trait. In this case, dissimilarities among species are computed using Euclidean distance. The number of species in t2d must match those in t2c. Or 2) a distance matrix of class dist that contains dissimilarities among species, no NAs are tolerated in the distance matrix.
  
obj: the objective function that is maximized. It can be one of three possibilities (QH, Q, H). QH = Quadratic entropy (Q) plus entropy (H); Q = Quadratic entropy; H = entropy.
  
phi: A parameter bounded between 0 and 1 that weights the importance of either quadratic entropy or entropy (default = 0.5). Phi of 1 corresponds to 100 percent Q, phi of 0.5 corresponds to 50 percent Q and 50 perfect H, phi of 0 corresponds to 100 percent H.
  
capd: A logical stating whether the distance matrix should be capped at the mean distance among species (default = FALSE). Mean distance is calculated as the average of all upper triangular entries in the distance matrix calculated from t2d.
  
euclid: A logical stating whether the distance matrix should be transformed to an Euclidean matrix if necessary (default = TRUE).


## The plotProbs() function takes the following arguments:

result: A saved object from function selectSpecies()

traits: A matrix of trait values where traits are columns and rows are species. If one trait is provided, then the function creates a 2D barplot of probabilities for each species. If two traits are provided, then the function creates a 3D barplot that illustrates probabilities of species located within a 2D trait space.

colors: An optional vector of colors for plotting that must include at least two valid color names. The default color scheme is a ramp palette of lightblue to blue.

xlim: Vector of two numbers denoting limits on x-axis.

ylim: Vector of two numbers denoting limits on y-axis.

xlab: Character string to describe x-axis.

ylab: Character string to describe y-axis.

zlab: Character string to describe z-axis (default = Probabilities).

distance: An optional number denoting distance between bars in 3d plot.

cex.lab: An optional number denoting the size of the labels. The default is set to 1.5.

box.col: An optional setting for the color of the box. The default setting is transparent.

xbase: The length of the base of each 3d bar along the x-axis

ybase: The length of the base of each 3d bar along the y-axis


# Part 1. Examples using one trait with known structure (evenly spaced integers)

Create a simple trait dataset for examples 1 through 4 using a species pool of 5 species with trait values 1 through 5.
```{r}
### Set size of species pool
Spp <- 5

### Set trait values for each species as integers from 1 to 5 (Spp)
### Note that we make this a matrix to pass it into the function
trait <- as.matrix(data.frame(trait = c(1:Spp)))

### Most datasets have species names as row names, so let's add arbitrary row names using letters
rownames(trait) <- c(letters[1:nrow(trait)])
```

## Example 1: Derive species assemblage with the following trait profile: {CWM = 3.5}

Let us start with the most basic use of the function: to derive a species abundance distribution where we only want to constrain the abundances so that the community has a community-weighted mean (CWM) trait equal to 3.5. This is equivalent to applying the FD::maxent function.

We will define four arguments in the function for this example 
t2c: this is the matrix of species trait values that we want to constrain
constraints: this is a vector of CWM trait values. In this case, we only have a one dimensional matrix of t2c, so this vector should contain only one element: 3.5
t2d: when you are not maximizing functional diversity, simply specify the same matrix here as you did for t2c
obj: this is the objective function that is being maximized. In this example we are not maximizing functional diversity, so we use the entropy function (H)
```{r}
### Store results from selectSpecies() into 'result1'
result1 <- selectSpecies(t2c = trait, constraints = c(trait=3.5), t2d = trait, obj = "H")

# Use the plotProbs() function to plot the abundance distribution
plotProbs(result1, trait, xlab = "Species")
```

Note that these results are equivalent to the FD::maxent function because all we are doing is constraining the species abundance distribution to have a CWM of 3.5 while maximizing entropy.
```{r}
### compare result1 with identical maxent output from FD package. Be sure to have the FD package installed.
round(FD::maxent(constr = c(3.5), states = trait)$prob, 5)
round(t(result1$prob), 5)
```

## Example 2: Derive species assemblage with the following trait profile: {CWM = 3.5, maximize Rao Q}

We will now see what happens when we maximize Rao Q (Q, quadratic entropy), an index of functional diversity, rather than maximizing entropy. 

```{r}
### Store results from selectSpecies() into 'result2'. Note the only difference with result1 is a different objective function (Q).
result2 <- selectSpecies(t2c = trait, constraints = c(trait=3.5), t2d = trait, obj = "Q")

# plot result2
plotProbs(result2, trait, xlab = "Species")
```

Interestingly, the CWM trait value is the same for both result1 and result2, but the species abundance distributions are radically different. When maximizing Rao Q, this makes the most functionally dissimilar species the most abundant, and all species in the middle of the trait distribution have vanishingly small abundances. This is not a desirable solution for ecological restoration. One way to fix this is to optimize both Rao Q and Entropy simultaneously.

## Example 3: Derive species assemblage with the following trait profile: {CWM = 3.5, maximize Rao Q and Entropy}

We will now see what happens when we maximize a function that additively combines both Rao Q (Q, quadratic entropy) and entropy (H).

```{r}
### Store results from selectSpecies() into 'result3'. Note the only difference with result2 is a different objective function (QH)
result3 <- selectSpecies(t2c = trait, constraints = c(trait=3.5), t2d = trait, obj="QH")

# plot result3
plotProbs(result3, trait, xlab = "Species")
```

Note that the abundance distribution still maximizes the most dissimilar species, but it evens out the abundances across all the species.

## Example 4: Derive species assemblage with the following trait profile: {maximize Rao Q and Entropy, no CWM trait constraint}

Suppose we do not want to constrain the abundances to satisfy a specific CWM trait value, and simply want to maximize functional diversity. If you do not want to constrain the results to satisfy a particular CWM trait value, then leave the t2c and constraints arguments blank.
```{r}
### Store results from selectSpecies() into 'result4'
result4 <- selectSpecies(t2d = trait, obj = "QH")

# plot result4
plotProbs(result4, trait, xlab = "Species")

```

# Part 2. Examples using two traits with known structure (evenly spaced integers)

In many cases, we will want to restore ecological communities with convergence toward one trait value, but we want to diversify a different trait. The following examples illustrate how to do so on a dataset with known structure to easily illustrate the results.

Create 2-dimensional trait matrix
```{r}
### 2-dimensional trait matrix of 16 species, evenly spaced between trait values 1 through 4
trait.matrix <- as.matrix(cbind(traitX = c(rep(1,4), rep(2,4), rep(3,4), rep(4,4)), traitY = c(rep(c(1,2,3,4),4))))

### specify species names
rownames(trait.matrix) <- c(letters[1:16])
```

### Example 5: Derive species assemblage with the following trait profile: {constrain trait X to a CWM = 3.5, maximize Rao Q of trait Y}
```{r}
### Create two evenly-spaced orthogonal traits
traitX <- matrix(c(rep(1,4), rep(2,4), rep(3,4), rep(4,4)))
traitY <- matrix(c(rep(c(1,2,3,4),4)))
rownames(traitX) <- c(letters[1:16]); colnames(traitX) <- c("traitX")
rownames(traitY) <- c(letters[1:16]); colnames(traitY) <- c("traitY")

### Store results from selectSpecies() into 'result5'
result5 <- selectSpecies(t2c = traitX, constraints = c(traitX=3.5), t2d = traitY, obj = "Q", capd = FALSE)

### plot result5
trait.matrix <- cbind(traitX, traitY)
plotProbs(result5, trait.matrix, cex.lab = 0.7)
```

Note how this result is not desirable because it suppresses the abundances of species with intermediate trait Y values. This is because we only maximized Rao Q. Let us see how the results change when we maximize both Rao Q and entropy.

### Example 6: Derive species assemblage with the following trait profile: {constrain trait X to a CWM = 3.5, maximize Rao Q + Entropy of trait Y}

```{r}
### Store results from selectSpecies() into 'result6'
# obj: select the QH objective function to maximize both Rao's Q and H, and cap the distance matrix by setting capd = TRUE
result6 <- selectSpecies(t2c = traitX, constraints = c(traitX=3.5), t2d = traitY, obj = "QH", capd = TRUE)

### plot result6
plotProbs(result6, trait.matrix, cex.lab = 0.7)
```

Note how this result evens out the abundances of species across the trait Y axis, while still creating a community with an average trait X value of 3.

# Part 3. An example using a real dataset

## Example 7: Derive species assemblage for a California serpentine grassland with the following trait profile: {constrain water use efficiency to a CWM = 67th percentile, maximize Rao Q of rooting depth}

Restoring ecosystems that are resilient to drought is often an important management goal. Drought tolerant plants can exhibit high water use efficiency (WUE), the rate of carbon assimilation per unit of water used. Therefore, selecting species with traits that converge on high water use efficiency is one goal of the project. Rooting depth also influences drought tolerance, but a drought-resilient community would likely exhibit a diversity of rooting depths to optimize complementary water use throughout the soil profile. Therefore, selecting species that optimize rooting depth diversity would be important.

Using a dataset of 48 species from a serpentine grassland in California, we first log transform and then standardize each variable to unit variance.
```{r}
### load serpentine data (available in the R package) 
data(serpentine)

### take logs and rescale to unit variance
wue <- data.frame(wue = scale(log(serpentine$wue)))
rootdepth <- data.frame(rootdepth = scale(log(serpentine$rootdepth)))

### transfer species row names
rownames(wue) <- rownames(serpentine)
rownames(rootdepth) <- rownames(serpentine)

# set constraint on wue as the 67% quantile of wue distribution
wue.constraint <- c(quantile(wue$wue, 0.67))
names(wue.constraint) <- c("wue")
```

We use the selectSpecies function to derive an assemblage with a high average WUE by constraining the assemblage to the 67th percentile of the distribution of WUE, but diversified the range of rooting depths by optimizing QH with a capped distance matrix. This output can be used to design a seed or planting mix for a restoration project by selecting species with the highest probabilities.

```{r}
### Store results from selectSpecies() into 'result7'
result7 <- selectSpecies(t2c = as.matrix(wue), constraints = c(wue.constraint), t2d = as.matrix(rootdepth), capd = TRUE, obj = "QH")

### plot result7
plotProbs(result7, traits = cbind(wue,rootdepth), xlab = "Water use efficiency", ylab = "Rooting depth", colors = c("darkolivegreen4", "gold2"), cex.lab = 0.7)
```

Note that this figure illustrates how the species with the highest probabilities exhibit a range of rooting depths but generally high water use efficiency. 

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/pineforest-data.R
\docType{data}
\name{pineforest}
\alias{pineforest}
\title{Functional trait data for understory species in ponderosa pine forest}
\format{
dataframe of 46 species and 2 traits
}
\source{
Laughlin, D.C., J.J. Leppert, M.M. Moore, and C.H. Sieg. 2010. A multi-trait test of the leaf-height-seed plant strategy scheme with 133 species from a pine forest flora. Functional Ecology 24:493-501.
}
\usage{
data(pineforest)
}
\description{
A dataset containing two traits for species in a pine forest.
The variables are as follows:
}
\details{
\itemize{
  \item species. species name
  \item flrdate. average flowering date in day of year
  \item leafcn. average leaf carbon-to-nitrogen ratio
}
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/tropicalforest-data.R
\docType{data}
\name{tropicalforest}
\alias{tropicalforest}
\title{Functional trait data for tree species in tropical forest}
\format{
dataframe of 41 species and 2 traits
}
\source{
McCarthy, James K. 2018. Predicting the diversity and functional composition of woody plant communities under climate change PhD Thesis, School of Biological Sciences, The University of Queensland. Advisor: Dr. John Dwyer. doi:10.14264/uql.2018.134
}
\usage{
data(tropicalforest)
}
\description{
A dataset containing two traits for species in a tropical forest.
The variables are as follows:
}
\details{
\itemize{
  \item species. species name
  \item sla. specific leaf area
  \item wd. wood density
}
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/selectSpecies.R
\name{selectSpecies}
\alias{selectSpecies}
\title{Select species based on traits}
\usage{
selectSpecies(
  t2c = NULL,
  constraints = NULL,
  t2d,
  obj = c("QH", "Q", "H"),
  phi = 0.5,
  capd = FALSE,
  euclid = TRUE
)
}
\arguments{
\item{t2c}{"Traits to constrain": A matrix of species trait values, where species are organized as rows and traits as columns. These should be numeric arrays, and no missing values are tolerated. Ordinal data will yield meaningful results, but nominal data entered as numeric vectors are invalid. Row and column names are optional. This matrix can be any dimension, but the number of traits should be less than the number of species.}

\item{constraints}{Trait constraints: A vector of trait values that serve as constants in the constraint equations. If not specified, the function will not constrain solutions to trait means. These trait contraints must be listed in the same order as columns in t2c. These constraints are community-weighted mean trait values, i.e., average traits weighted by the relative abundance of each species.}

\item{t2d}{"Traits to diversify": Can be 1) a matrix of species trait values to diversify where species are organized as rows and traits as columns. NAs are tolerated as long as each pair of species can be compared by at least one trait. In this case, dissimilarities among species are computed using Euclidean distance. The number of species in t2d must match those in t2c. Or 2) a distance matrix of class 'dist' that contains dissimilarities among species, no NAs are tolerated in the distance matrix.}

\item{obj}{Objective function: The objective function to optimise, one of three possibilities = c("QH", "Q", "H"). QH = Quadratic entropy (Q) plus entropy (H'); Q = Quadratic entropy; H = entropy.}

\item{phi}{A parameter bounded between 0 and 1 that weights the importance of either quadratic entropy or entropy (default = 0.5). Phi of 1 corresponds to 100 percent Q, phi of 0.5 corresponds to 50 percent Q and 50 perfect H', phi of 0 corresponds to 100 percent H'.}

\item{capd}{A logical stating whether the distance matrix should be capped at the mean distance among species (default = FALSE). Mean distance is calculated as the average of all upper triangular entries in the distance matrix calculated from t2d.}

\item{euclid}{A logical stating whether the distance matrix should be transformed to an Euclidean matrix if necessary (default = TRUE).}
}
\value{
A list with the elements: \item{prob}{Probabilities, i.e. optimal solutions of species relative abundance} \item{cwm_t2d}{Community-weighted mean trait values of resulting community for traits that were diversified, computed as probabilities x t2d using matrix multiplication} \item{cwm_t2c}{Community-weighted mean trait values of resulting community for traits that were constrained, computed as probabilities x t2d using matrix multiplication} \item{H}{Final entropy of community} \item{Q}{Final Rao Q of community} \item{objval}{Values of the objective function being maximized. The last value is the maximum.} \item{lagrange}{Lagrange multipliers.} \item{hessian}{The Hessian at the optimal solution.}
}
\description{
This function returns a probability distribution for a species pool based on their traits and a desired trait profile (Laughlin 2014). It can simultaneously constrain specific trait value(s) and optimise functional diversity.
}
\examples{
### 1 trait constraint with maximum entropy
Spp <- 5 #S = number of species
trait <- as.matrix(data.frame(trait=c(1:Spp)))
rownames(trait) <- c(letters[1:nrow(trait)])
result1 <- selectSpecies(t2c=trait, constraints=c(trait=3.5), t2d=trait, obj="H", capd=FALSE)
### compare result1 with virtually identical maxent output from FD package
#FD::maxent(constr=c(3.5),states=trait)$prob
### 1 trait constraint with maximum functional diversity
result2 <- selectSpecies(t2c=trait, constraints=c(trait=3.5), t2d=trait, obj="Q", capd=FALSE)
### 1 trait constraint with maximum functional diversity and entropy
result3 <- selectSpecies(t2c=trait, constraints=c(trait=3.5), t2d=trait, obj="QH", capd=FALSE)

### Plot results
plotProbs(result1,trait, xlab="Trait")
plotProbs(result2,trait, xlab="Trait")
plotProbs(result3,trait, xlab="Trait")

### 1 trait and no trait constraint
result4 <- selectSpecies(t2d=trait, obj="QH", capd=FALSE)
plotProbs(result4,trait, xlab="Trait")

##### 2 traits: Constrain trait X at X=3, diversify trait Y
traitX <- matrix(c(rep(1,4),rep(2,4),rep(3,4),rep(4,4)))
traitY <- matrix(c(rep(c(1,2,3,4),4)))
rownames(traitX) <- c(letters[1:16]); colnames(traitX) <- c("traitX")
rownames(traitY) <- c(letters[1:16]); colnames(traitY) <- c("traitY")

result5 <- selectSpecies(t2c=traitX,constraints=c(traitX=3),t2d=traitY,obj="Q",capd=FALSE)
result6 <- selectSpecies(t2c=traitX,constraints=c(traitX=3),t2d=traitY,obj="QH",capd=TRUE)

trait.matrix <- cbind(traitX, traitY)
plotProbs(result5,trait.matrix)
plotProbs(result6,trait.matrix)

##### 3 traits: Constrain trait Z to value 2.5, diversify trait X and Y
traitZ <- as.matrix(data.frame(c(1,3,2,2,3,1,2,3,1,2,1,3,2,3,2,2)))
rownames(traitZ) <- c(letters[1:16]); colnames(traitZ) <- c("traitZ")
result7 <- selectSpecies(t2c=traitZ,constraints=c(traitZ=2.5),t2d=trait.matrix, capd=TRUE, obj="QH")
plotProbs(result7,trait.matrix)

}
\references{
Laughlin, D.C. 2014. Applying trait-based models to achieve functional targets for theory-driven ecological restoration. Ecology Letters, 17, 771-784.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/serpentine-data.R
\docType{data}
\name{serpentine}
\alias{serpentine}
\title{Functional trait data for species in serpentine grassland}
\format{
dataframe of 48 species and 2 traits
}
\source{
Funk, J.L. & Wolf, A.A. 2016. Testing the trait based community framework: Do functional traits predict competitive outcomes? Ecology 97:2206-2211.
}
\usage{
data(serpentine)
}
\description{
A dataset containing two traits for species in a serpentine grassland.
The variables are as follows:
}
\details{
\itemize{
  \item species. species name
  \item wue. average water use efficiency, rate of carbon assimilation per unit of water used
  \item rootdepth. average rooting depth in soil
}
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plotProbs.R
\name{plotProbs}
\alias{plotProbs}
\title{Plots results from the selectSpecies function}
\usage{
plotProbs(
  result,
  traits,
  colors = c("lightblue", "blue"),
  xlim = NULL,
  ylim = NULL,
  xlab = NULL,
  ylab = NULL,
  zlab = "Probability",
  distance = 0.3,
  cex.lab = 1.5,
  box.col = "transparent",
  xbase = 0.5,
  ybase = 0.5,
  ...
)
}
\arguments{
\item{result}{A saved object from function selectSpecies()}

\item{traits}{A matrix of trait values where traits are columns and rows are species. If one trait is provided, then the function creates a 2D barplot of probabilities for each species. If two traits are provided, then the function creates a 3D barplot that illustrates probabilities of species located within a 2D trait space.}

\item{colors}{An optional vector of colors for plotting that must include at least two valid color names. The default color scheme is a ramp palette of lightblue to blue.}

\item{xlim}{Vector of two numbers denoting limits on x-axis.}

\item{ylim}{Vector of two numbers denoting limits on y-axis.}

\item{xlab}{Character string to describe x-axis.}

\item{ylab}{Character string to describe y-axis.}

\item{zlab}{Character string to describe z-axis. The default axis names is "Probabilities".}

\item{distance}{An optional number denoting distance between bars in 3d plot.}

\item{cex.lab}{An optional number denoting the size of the labels. The default is set to 1.5.}

\item{box.col}{An optional setting for the color of the box. The default setting is transparent.}

\item{xbase}{The length of the base of each 3d bar along the x-axis}

\item{ybase}{The length of the base of each 3d bar along the y-axis}

\item{...}{Additional arguments to pass to barplot() or lattice::cloud()}
}
\value{
2D barplot of probabilities for each species or 3D barplot that illustrates probabilities of species located within a 2D trait space
}
\description{
This function plots results (species probabilities/optimum solutions) from the selectSpecies() function
}
\examples{
### 1 trait constraint with maximum functional diversity and entropy
Spp <- 5 #S = number of species
trait <- as.matrix(data.frame(trait=c(1:Spp)))
rownames(trait) <- c(letters[1:nrow(trait)])
result1 <- selectSpecies(t2c=trait, constraints=c(3.5), t2d=trait, obj="QH", capd=FALSE)
plotProbs(result1,trait, xlab="Trait")

##### 2 traits: Constrain trait X to value 2.5, diversify trait Y
traitX <- matrix(c(rep(1,3),rep(2,3),rep(3,3)))
traitY <- matrix(c(rep(c(1,2,3),3)))
rownames(traitX) <- c(letters[1:9]); colnames(traitX) <- c("traitX")
rownames(traitY) <- c(letters[1:9]); colnames(traitY) <- c("traitY")
result2 <- selectSpecies(t2c=traitX,constraints=c(traitX=2.5),t2d=traitY,capd=TRUE,obj="QH")
plotProbs(result2,traits = cbind(traitX, traitY))
}
